﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace sigIDp1_Demo
{
    public partial class Form1 : Form
    {
        string fingerStr, bmpStr;
        string[] fingers;

        public Form1()
        {
            InitializeComponent();
        }

        private void cbDialogDelay_SelectedIndexChanged(object sender, EventArgs e)
        {
            short val = Convert.ToInt16(cbDialogDelay.Text);
            axSigIDp11.SetDialogDelay(ref val);
        }

        private void cmdFingFile_Click(object sender, EventArgs e)
        {
            string loc = "C:\\sff.tft";
            int retVal = axSigIDp11.GetFingerprintFile(ref loc);
            if (retVal == 1)
            {
                MessageBox.Show("Error capturing fingerprint file.");
            }
        }

        private void cmdValFingFile_Click(object sender, EventArgs e)
        {
            string loc = "C:\\sff.tft";
            int retVal = axSigIDp11.ValidateFingerprintFile(ref loc);

            if (retVal == 0)
            {
                MessageBox.Show("Fingerprint is verified!");
            }
            else
            {
                MessageBox.Show("Fingerprint is NOT verified.");
            }
        }

        private void cmdFingStr_Click(object sender, EventArgs e)
        {
            fingerStr = axSigIDp11.GetFingerprintString();

            if (fingerStr == "0")
            {
                MessageBox.Show("Error creating fingerprint string.");
            }
            else
            {
                TextWriter tw = new StreamWriter("C:\\finger.txt");
                tw.Write(fingerStr);
                tw.Close();

            }
        }

        private void cmdValFingStr_Click(object sender, EventArgs e)
        {
            int retVal = axSigIDp11.ValidateFingerprintString(ref fingerStr);

            if (retVal == 0)
            {
                MessageBox.Show("Fingerprint is verified!");
            }
            else
            {
                MessageBox.Show("Fingerprint is NOT verified.");
            }
        }

        private void cmdWriteBMP_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint BMP";
            fd.Filter = "BMP Files (*.bmp)|*.bmp";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateBmp(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdWriteLowResBMP_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint BMP";
            fd.Filter = "BMP Files (*.bmp)|*.bmp";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateLowResBmp(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdWriteJPG_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint JPG";
            fd.Filter = "JPG Files (*.jpg)|*.jpg";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateJpg(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdWriteLowResJPG_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint JPG";
            fd.Filter = "JPG Files (*.jpg)|*.jpg";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateLowResJpg(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdWriteTIF_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint TIF";
            fd.Filter = "TIF Files (*.tif)|*.tif";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateTif(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdWriteLowResTIF_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint TIF";
            fd.Filter = "TIF Files (*.tif)|*.tif";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;
            int retVal = axSigIDp11.CreateLowResTif(ref loc);

            if (retVal != 0)
            {
                MessageBox.Show("Error writing image.");
            }
        }

        private void cmdBMPBufferBytes_Click(object sender, EventArgs e)
        {
            byte[] bytes;
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint BMP";
            fd.Filter = "BMP Files (*.bmp)|*.bmp";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;

            bytes = (byte[])axSigIDp11.GetBmpBufferBytes();

            if (bytes != null)
            {
                FileStream fStream = new FileStream(loc, FileMode.OpenOrCreate, FileAccess.Write, FileShare.None);
                fStream.Write(bytes, 0, bytes.Length);
                fStream.Close();
            }
            else
            {
                MessageBox.Show("Did not create image.");
            }
        }

        private void cmdBMPBufferBytesLowRes_Click(object sender, EventArgs e)
        {
            byte[] bytes;
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint BMP";
            fd.Filter = "BMP Files (*.bmp)|*.bmp";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;

            bytes = (byte[])axSigIDp11.GetBmpBufferBytesLowRes();

            if (bytes != null)
            {
                FileStream fStream = new FileStream(loc, FileMode.OpenOrCreate, FileAccess.Write, FileShare.None);
                fStream.Write(bytes, 0, bytes.Length);
                fStream.Close();
            }
            else
            {
                MessageBox.Show("Did not create image.");
            }
        }

        private void cmdGetBMPStr_Click(object sender, EventArgs e)
        {
            bmpStr = axSigIDp11.GetBmpString();
        }

        private void cmdSetBMPStr_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd;
            fd = new SaveFileDialog();

            fd.Title = "Save Fingerprint BMP";
            fd.Filter = "BMP Files (*.bmp)|*.bmp";
            fd.FilterIndex = 1;
            fd.ShowDialog();

            string loc = fd.FileName;

            if (bmpStr != "")
            {
                axSigIDp11.SetBmpString(ref bmpStr, ref loc);
            }
        }

        private void cmdGetDialogDelay_Click(object sender, EventArgs e)
        {
            MessageBox.Show(axSigIDp11.GetDialogDelay() + "");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //THIS IS AN EXAMPLE SHOWING HOW TO COMPARE A NEWLY-CAPTURED FINGERPRINT AGAINST A SERIES OF PREVIOUSLY-CAPTURED FINGERPRINTS, SEARCHING
            //FOR A MATCH. THIS EXAMPLE INCLUDES USE OF THE cmdIDTemplate_Click() HANDLER FURTHER BELOW, WHICH IS BEHIND THE "Set ID Template and Identify User"
            //BUTTON ON THE FORM.
            //YOU CAN ASSIGN 4 STRINGS TO THE fingers() STRING ARRAY BELOW HERE IN THE Form_Load HANDLER. THE STRINGS SHOULD BE THE RETURN OF CALLS TO
            //THE GetFingerprintString() FUNCTION. YOU WILL NEED TO CAPTURE THESE SEPARATELY AND ASSIGN THEM EITHER AS HARD_CODED VALUES IN THE ARRAY BELOW.
            //A CALL TO SetIdentificationFingerprint() WILL CAPTURE A NEW FINGERPRINT TO BE COMPARED TO THE STRINGS IN THE fingers() ARRAY.
            //FINALLY, YOU CAN THEN USE IdentifyUser() TO PASS IN ONE OF THE finger() STRINGS TO COMPARE AGAINST THE NEWLY-CAPTURED FINGERPRINT.
            //OF COURSE, ULTIMATELY YOU CAN USE THIS SYSTEM IN WHATEVER MANNER FITS YOUR APPLICATION BEST. THIS IS JUST AN EXAMPLE OF HOW TO USE THIS FEATURE.
            fingers = new string[4];

            fingers[0] = ""; //ASSIGN FINGERPRINT #0 HERE, THE RETURN FROM A CALL TO GetFingerprintString()

            fingers[1] = ""; //ASSIGN FINGERPRINT #1 HERE, THE RETURN FROM A CALL TO GetFingerprintString()

            fingers[2] = ""; //ASSIGN FINGERPRINT #2 HERE, THE RETURN FROM A CALL TO GetFingerprintString()

            fingers[3] = ""; //ASSIGN FINGERPRINT #3 HERE, THE RETURN FROM A CALL TO GetFingerprintString()
        }

        private void cmdIDTemplate_Click(object sender, EventArgs e)
        {
            short retVal = axSigIDp11.SetIdentificationFingerprint();

            if (retVal == 0)
            {
                bool verified = false;

                for (int i = 0; i < fingers.Length; i++)
                {
                    retVal = axSigIDp11.IdentifyUser(ref fingers[i]);

                    if (retVal == 0)
                    {
                        MessageBox.Show("Index " + i + " has been verified.");
                        verified = true;
                        break;
                    }
                }

                if (verified == false)
                {
                    MessageBox.Show("Cannot locate user.");
                }

                axSigIDp11.CloseIdentificationFingerprint();
            }
            else
            {
                MessageBox.Show("Error creating ID template.");
            }
        }
    }
}
